package test;

import interfaces.Image;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

class GrayscaleImage implements Image {
	private BufferedImage image;

	public GrayscaleImage(String filename) throws IOException {
		this.image = ImageIO.read(new File(filename));

		if (this.image.getType() != BufferedImage.TYPE_BYTE_GRAY) {
			BufferedImage gs = new BufferedImage(image.getWidth(),
					image.getHeight(), BufferedImage.TYPE_BYTE_GRAY);
			gs.getGraphics().drawImage(this.image, 0, 0, null);
			this.image = gs;
		}
	}

	public void setPixel(int x, int y, int value) {
		image.getRaster().setSample(x, y, 0, value);
	}

	@Override
	public int getPixel(int x, int y) {
		return image.getRaster().getSample(x, y, 0);
		// return image.getData().getSample(x, y, 0);
	}

	@Override
	public int getWidth() {
		return image.getWidth();
	}

	@Override
	public int getHeight() {
		return image.getHeight();
	}
}
